<!DOCTYPE html>
<html lang="sv">

<head>
    <meta charset="utf-8">
    <title>Wizard's Lizard</title>
    <link rel="stylesheet" href="">
</head>

<body>
    <script>
        // Skapa canvas
        var canvas = document.createElement("canvas");
        var ctx = canvas.getContext("2d");
        canvas.width = 512;
        canvas.height = 480;
        document.body.appendChild(canvas);

        // Ladda bilderna
        var bgReady = false;
        var bgImage = new Image();
        bgImage.onload = function() {
            bgReady = true;
        };
        bgImage.src = "images/background.png";

        var heroReady = false;
        var heroImage = new Image();
        heroImage.onload = function() {
            heroReady = true;
        };
        heroImage.src = "images/hero.png";

        var monsterReady = false;
        var monsterImage = new Image();
        monsterImage.onload = function() {
            monsterReady = true;
        };
        monsterImage.src = "images/monster.png";

        // Spelobjekten
        var hero = {
            speed: 1,
            x: 0,
            y: 0
        }
        var monster = {
            x: 0,
            y: 0
        }
        var monstersCaught = 0;

        // Lagrar knapptryckningar
        var keysDown = {};

        // Vi lyssnar på knapptryckningar
        addEventListener("keydown", function(e) {
            keysDown[e.keyCode] = true;
        }, false);

        addEventListener("keyup", function(e) {
            delete keysDown[e.keyCode];
        }, false);

        // Återställ spelet när ett monster fångats
        var reset = function() {
            hero.x = canvas.width / 2;
            hero.y = canvas.height / 2;

            // Spawna monster någonstans på spelplanen
            monster.x = 32 + (Math.random() * (canvas.width - 64));
            monster.y = 32 + (Math.random() * (canvas.height - 64));
        }

        // Updatera objektens position vid tryck på piltangenter
        var update = function() {
            if (38 in keysDown) {
                hero.y -= hero.speed;
            }
            if (40 in keysDown) {
                hero.y += hero.speed;
            }
            if (37 in keysDown) {
                hero.x -= hero.speed;
            }
            if (39 in keysDown) {
                hero.x += hero.speed;
            }

            // Träffar dom varandra?
            if (hero.x <= (monster.x + 32) && monster.x <= (hero.x + 32) && hero.y <= (monster.y + 32) && monster.y <= (hero.y + 32)) {
                ++monstersCaught;
                reset();
            }
        }

        // Rita ut alla objekt
        var render = function() {
            if (bgReady) {
                ctx.drawImage(bgImage, 0, 0)
            }

            if (heroReady) {
                ctx.drawImage(heroImage, hero.x, hero.y);
            }

            if (monsterReady) {
                ctx.drawImage(monsterImage, monster.x, monster.y);
            }

            // Poängen
            ctx.fillStyle = "rgb(250, 250, 250)";
            ctx.font = "24px Helvetica";
            ctx.textAlign = "left";
            ctx.textBaseline = "top";
            ctx.fillText("Fångade monster: " + monstersCaught, 32, 32);
        }

        // Spelloopen
        var main = function() {
            update();
            render();

            // Rita om så snart som möjligt
            window.requestAnimationFrame(main);
        };

        // Kör igån spelet
        reset();
        main();
    </script>
</body>

</html>
